<!DOCTYPE html>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd" lang="en-us" xml:lang="en-us" class="no-feedback" data-mc-search-type="Stem" data-mc-help-system-file-name="index.xml" data-mc-path-to-help-system="../../" data-mc-target-type="WebHelp2" data-mc-runtime-file-type="Topic" data-mc-preload-images="false" data-mc-in-preview-mode="false" data-mc-toc-path="Reports">
    <head>
        <meta charset="utf-8" />
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><title>Exporting Data</title>
        
        <link href="../../Skins/Default/Stylesheets/TextEffects.css" rel="stylesheet" />
        <link href="../../Skins/Default/Stylesheets/Topic.css" rel="stylesheet" />
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" />
        <script src="../../Resources/Scripts/jquery.min.js">
        </script>
        <script src="../../Resources/Scripts/plugins.min.js">
        </script>
        <script src="../../Resources/Scripts/MadCapAll.js">
        </script>
    </head>
    <map id="map1" name="map1">
        <area shape="rectangle" coords="840,44,1093,87" href="http://www.rapid7.com/products/metasploit/download.jsp" target="_blank" />
        <area shape="rectangle" coords="1107,48,1211,80" href="http://www.rapid7.com/products/metasploit/" target="_blank" />
    </map>
    <body>
        <p class="MCWebHelpFramesetLink MCWebHelpFramesetLinkTop" style="display: none;"><a href="../../index.html#16-reports/exporting-project-data.html">Open topic with navigation</a>
        </p>
        <h1>Exporting Data</h1>
        <p>A data export enables you  to routinely back up project data and create an archive of your tests. When you export data from a project, its contents are copied and saved to a file that can be imported into other projects or shared with other instances of <span class="VariablesProductName">Metasploit Pro</span>. All exports can be  downloaded from the Exports area of the web interface or from the exports directory. </p>
        <h2>Exports Directory </h2>
        <p>When <span class="VariablesProductName">Metasploit Pro</span> generates an export, it stores a copy of the file in  <code>/path/to/Metasploit/apps/pro/exports</code>. The files that are stored in this directory will match the list of exports displayed in the web interface. </p>
        <p>You can go to the exports directory to download or view exported data; however, you should not make any changes directly to the default exports directory. If you need to modify the export files, you should make a copy the exports directory and make your changes from the new directory.  Any changes that you make directly to the export files can cause disparities between the metadata that displays for the file in the web&#160;interface and the file itself. </p>
        <p>If you need to remove exports from a project, you should do it from within the web interface. Do not delete them directly from the exports directory.</p>
        <h3>Viewing Exports Generated with <span class="VariablesProductName">Metasploit Pro</span> 4.8 and Earlier</h3>
        <p>All exports generated with  4.8 and earlier are stored in <code>/path/to/Metasploit/apps/pro/reports</code>. These exports were created with an older version of <span class="VariablesProductName">Metasploit Pro</span> and were not migrated to the exports directory that was added in <span class="VariablesProductName">Metasploit Pro</span> 4.9. These files will not be listed or accessible from the web interface. </p>
        <h2><a name="Export"></a>Export Logs</h2>
        <p>The export log maintains a historical record of all export-related events. <span class="VariablesProductName">Metasploit Pro</span> automatically updates the export log each time you export data from a project. If you experience any issues with an export, you can view the export log to find stack trace errors and troubleshoot them.</p>
        <h3>Viewing the Export Log</h3>
        <p>You can find and view the export log  in the following directory: <code>/path/to/Metasploit/apps/pro/ui/log</code>. The export log is named <code>exports.log</code>. </p>
        <h3>Clearing the Export Log</h3>
        <p>To clear the export log, you will need remove it from the log directory, which is located at <code>/path/to/Metasploit/apps/pro/ui/log</code>. <span class="VariablesProductName">Metasploit Pro</span> will generate a new export log if it detects that one does not exist. </p>
        <p class="Note" data-mc-autonum="&lt;b&gt;Note:&lt;/b&gt; &#160;"><span class="autonumber"><span><b>Note:</b> &#160;</span></span>Before you delete the export log, you should make a copy of it in case you need it for reference later. </p>
        <h2>Notification Center Statuses for Exports</h2>
        <p>The Notification Center  alerts you when an export has started, finished, or encountered an error. The Notification&#160;Center appears as an icon in the upper-right corner of the global toolbar and turns green when there is an alert is available for you to review. You can click on the Notification Center icon to view a list of notifications for all projects. </p>
        <p>
            <img src="../Resources/Images/exports/exports-notification-center_578x99.png" title="Notification Center " alt="Notification Center " style="width: 578;height: 99;" />
        </p>
        <p>The Notification&#160;Center displays the following statuses for exports: </p>
        <ul>
            <li value="1"><b>Export started</b> - This status indicates that the export has started. </li>
            <li value="2"><b>Export finished</b> -This status indicates that the export has completed without errors and is ready for you to download. You can click on this alert to open the Exports page, which will list all of the export files that have been generated for the project. You can sort by the creation date to find the latest export file.</li>
            <li value="3"><b>Problem with export</b> - This status indicates that there was an issue with the export and it was not able to finish. You will need to view the export log to troubleshoot the issue. For more information on export logs, see <MadCap:conditionalText data-mc-conditions="Pro_Help_Conditions.OnlineOnly"> <![CDATA[ ]]><a href="#Export" class="online MCXref xref xrefonline">Export Logs</a></MadCap:conditionalText>.</li>
        </ul>
        <h2>Export Types</h2>
        <p data-mc-conditions=""><span class="VariablesProductName">Metasploit Pro</span> offers the following export types:</p>
        <ul>
            <li value="1" data-mc-conditions=""><b>XML export</b> - An XML file that contains the attributes for most of the objects in a project and can be imported into another project. XML exports are particularly useful if you have a data set that you want to reuse in another project or share with another instance of <span class="VariablesProductName">Metasploit Pro</span>. For example, you can export an XML&#160;of project data if you want to reuse the scan data from a particular project. </li>
            <li value="2" data-mc-conditions=""><b>Workspace ZIP</b> - A zip that contains an XML export and any  loot files, report files, and tasks logs. This export type is useful if you want to  back up the data and contents in a project or share the project with other instances of <span class="VariablesProductName">Metasploit Pro</span>. </li>
            <li value="3" data-mc-conditions=""><b>Replay script</b> - A batch file that reruns tasks that opened sessions on target hosts. A replay script consists of multiple resource files (.rc). <span class="VariablesProductName">Metasploit Pro</span> creates a resource file for each session it opens. You can run a replay script from the pro console or msfconsole. </li>
            <li value="4" data-mc-conditions=""><b>PWDump</b> - A text file that contains all of the credentials for a project, including plaintext passwords, SMB hashes, and SSH keys. Credentials can be masked to enumerate user names only. </li>
        </ul>
        <h3>XML&#160;Exports</h3>
        <p>When you export your project as an XML file, it contains most of the data that you see from the Analysis area of a project--with a few exceptions. The exported XML file contains most of the objects in a project's database and their attributes; it does not include any files that are associated with the objects in a project, such as task logs, generated reports, and loot files. </p>
        <p>When you view the XML export file, you will see the following objects: </p>
        <ul>
            <li value="1"><b>Hosts</b> - Contains the details for each host in the project, including the following attributes: notes, tags, vulnerabilities, credentials, and sessions. It also include host details, such as the  host ID, IP address, MAC&#160;address, host name, OS name, OS flavor, OS&#160;service pack, and purpose. </li>
            <li value="2"><b>Events</b> - Contains the event log for the project. Each event includes the workspace ID, event creation date, event name, and name of the user who launched the task. </li>
            <li value="3"><b>Sessions</b> - Contains the details for each session obtained in the project, including the following attributes: host ID, session type, module used, session description, port used, and session open/close dates. </li>
            <li value="4"><b>Services</b> - Contains the details for each service discovered in the project, including the service ID, host ID, port number, protocol type, state, service name,  creation date, and modification date. </li>
            <li value="5"><b>Credentials</b> - Contains the details for each credential stored in the project, including the credential ID, service ID, user name, password, creation date, and modification date.</li>
            <li value="6"><b>Web sites</b> - Contains the details for each web server discovered, including the website ID, service ID, host address, VHOST address, HTTP port, creation date, and modification date.</li>
            <li value="7"><b>Web pages</b> - Contains the details for each web page discovered, including the web page ID, HTTP response code, VHOST address, web server address, HTTP port, content type, page content, creation date, and modification date.</li>
            <li value="8"><b>Web forms</b> - Contains the details for each web form discovered, including the web form ID, form path, request method, VHOST address, web server address, HTTP port, content type, page content, creation date, and modification date.</li>
            <li value="9"><b>Web vulnerabilities</b> - Contains the details for each web vulnerability discovered, including the vulnerability category, vulnerability description, vulnerability confidence ranking, request method, vulnerability name, HTTP port, proof text, VHOST address, and vulnerability blame. </li>
        </ul>
        <p class="Note" data-mc-autonum="&lt;b&gt;Note:&lt;/b&gt; &#160;"><span class="autonumber"><span><b>Note:</b> &#160;</span></span>Additional attributes may be available for each object; however, this list covers the most common attributes for each object. </p>
        <h4>Creating an XML&#160;Export of Project Data</h4>
        <ol>
            <li value="1">Open the project from which you want to export data. </li>
            <li value="2">Select <b class="UISelection">Exports &gt;&#160;Export Data</b> from the Project tab bar. The <b class="UISelection">Export Data</b> page appears. <br /><br /><img src="../Resources/Images/exports/exports-project-tab_545x73.png" style="width: 545;height: 73;" /></li>
            <li value="3">Select <b class="UISelection">XML&#160;Export</b> from the <b class="UISelection">Export Format</b> section. <br /><br /><img src="../Resources/Images/exports/exports-xml-type_547x48.png" style="width: 547;height: 48;" /></li>
            <li value="4">Replace the export file name with a custom name, if you do not want to use the default name. (Optional)</li>
            <li value="5">Define the hosts you want to explicitly include in the <b class="UISelection">Included addresses</b> field. (Optional)<br /></li>
            <li value="6">Define the hosts you want to explicitly exclude in the <b class="UISelection">Excluded addresses</b> field. (Optional)</li>
        </ol>
        <ol start="5" data-mc-continue="true">
            <li value="7">Select the <b class="UISelection">Mask credentials</b> option from the <b class="UISelection">Export Options</b> section if you do not want to include credentials in the export.<br /><br />The credentials will be replaced with <code>**MASKED**</code> in the XML file. If you import the XML file into a project, the credentials will not be included.</li>
            <li value="8">Click the <b class="UISelection">Export Data</b> button. </li>
            <li class="indentedListNextLine" value="9" data-mc-autonum=""><span class="autonumber"><span></span></span>When the export begins, you will be taken back to the Exports page. The Exports page displays an "Export creation queued" message. </li>
            <li class="indentedListNextLine" value="10" data-mc-autonum=""><span class="autonumber"><span></span></span>
                <img src="../Resources/Images/exports/exports-list-queued_545x216.png" title="Exports list" alt="Exports list" style="width: 545;height: 216;" />
            </li>
            <li class="indentedListNextLine" value="11" data-mc-autonum=""><span class="autonumber"><span></span></span>The Notification Center icon will turn green and alert you when  the export starts and completes. You can click on the Notification Center icon to view a list of system wide alerts. When the export completes, you can click on the notification message or you can select <b class="UISelection">Exports &gt;&#160;Show Exports</b> from the Project tab bar to access the Exports area. </li>
            <li class="indentedListNextLine" value="12" data-mc-autonum=""><span class="autonumber"><span></span></span>When the export is ready, it will listed be at the top of the Exports List. It will use the following naming convention: <code>export-[current date and time]</code>. If you do not see it at the top of the Exports List, click on the Create Date column name to sort the list by descending creation date.</li>
            <li class="indentedListNextLine" value="13" data-mc-autonum=""><span class="autonumber"><span></span></span>If an error occurred during the export and the export was unable to complete, you can view the export log to identify and troubleshoot any errors that occurred. For more information on export logs, see <MadCap:conditionalText data-mc-conditions="Pro_Help_Conditions.OnlineOnly"> <![CDATA[ ]]><a href="#Export" class="online MCXref xref xrefonline">Export Logs</a></MadCap:conditionalText>.<br style="color: #ff1493;" /></li>
        </ol>
        <h3>Workspace ZIP</h3>
        <p>A workspace ZIP contains an XML export, which details the attributes for most of the objects in a project, and any associated directories that contain loot files, report files, and tasks logs. You can export a workspace ZIP to make a copy of a project, its data, and its files. This is useful when you want to back up your findings or when you want to import the data into other projects. </p>
        <p>When you export a project, <span class="VariablesProductName">Metasploit Pro</span> generates a ZIP file that contains the following:</p>
        <ul>
            <li value="1"><b>Exported XML file</b> - Contains most of the objects in a project, including hosts, services, sessions, credentials, module details, and events. </li>
            <li value="2"><b>Reports directory</b> - Contains all of the generated reports for the project.</li>
            <li value="3"><b>Tasks directory</b> - Contains texts file that detail each task run. </li>
            <li value="4"><b>Loot directory</b> - Contains the loot files for the project, including hashes and SSH keys.</li>
        </ul>
        <h4>Generating a ZIP of the Project</h4>
        <ol start="1">
            <li value="1">Open the project from which you want to export replay scripts. </li>
            <li value="2">Select <b class="UISelection">Exports &gt;&#160;Export Data</b> from the Project tab bar. The <b class="UISelection">Export Data</b> page appears. <br /><br /><img src="../Resources/Images/exports/exports-project-tab_546x73.png" style="width: 546;height: 73;" /><br /></li>
            <li value="3">Choose <b class="UISelection">ZIP&#160;Workspace</b> from the <b class="UISelection">Export Format</b> section.<br /><br /><img src="../Resources/Images/exports/exports-zip-type_546x47.png" style="width: 546;height: 47;" /></li>
            <li value="4">Replace the export file name with a custom name, if you do not want to use the default name. (Optional)</li>
            <li value="5">Use the <b class="UISelection">Included addresses</b> to explicitly define the hosts you want to include in the export. (Optional)<br /></li>
            <li value="6">Use the <b class="UISelection">Excluded addresses</b> to explicitly define the hosts you want to exclude from the export. (Optional)</li>
            <li value="7">If you do not want to include credentials in the export,  select the <b class="UISelection">Mask credentials</b> option from the <b class="UISelection">Export Options</b> section.</li>
            <li value="8">Click the <b class="UISelection">Export Data</b> button. </li>
            <li class="indentedListNextLine" value="9" data-mc-autonum=""><span class="autonumber"><span></span></span>When the export begins, you will be taken back to the Exports page. The Exports page displays an "Export creation queued" message. </li>
            <li class="indentedListNextLine" value="10" data-mc-autonum=""><span class="autonumber"><span></span></span>The Notification Center icon will turn green and alert you when  the export starts and completes.  You can click on the Notification Center icon to view a list of system wide alerts. When the export completes, you can click on the notification message or you can select<b class="UISelection"> Exports &gt;&#160;Show Exports</b> from the Project tab bar to access the Exports area. </li>
            <li class="indentedListNextLine" value="11" data-mc-autonum=""><span class="autonumber"><span></span></span>
                <img src="../Resources/Images/exports/exports-list-queued-2_456x216.png" style="width: 456;height: 216;" />
            </li>
            <li class="indentedListNextLine" value="12" data-mc-autonum=""><span class="autonumber"><span></span></span>The ZIP file will listed be at the top of the Exports List. It will use the following naming convention: <code>export-[current date and time]</code>. If you do not see it at the top of the Exports List, click on the Create Date column name to sort the list by descending creation date.</li>
            <li class="indentedListNextLine" value="13" data-mc-autonum=""><span class="autonumber"><span></span></span>If an error occurred during the export and the export was unable to complete, you can view the export log to identify and troubleshoot any errors that occurred. For more information on export logs, see <MadCap:conditionalText data-mc-conditions="Pro_Help_Conditions.OnlineOnly"> <![CDATA[ ]]><a href="#Export" class="online MCXref xref xrefonline">Export Logs</a></MadCap:conditionalText>.</li>
        </ol>
        <h3>Replay Scripts</h3>
        <p>A replay script is a batch file that reruns tasks that opened sessions on target hosts. You can export a replay script to automate successful attacks through the pro console or msfconsole. When you export a replay script, <span class="VariablesProductName">Metasploit Pro</span> creates a resource file for each opened session and compresses them into a ZIP file.</p>
        <h4>Exporting Replay Scripts</h4>
        <ol start="1">
            <li value="1">Open the project from which you want to export replay scripts. </li>
            <li value="2">Select <b class="UISelection">Exports &gt;&#160;Export Data</b> from the Project tab bar. The <b class="UISelection">Export Data</b> page appears. <br /><br /><img src="../Resources/Images/exports/exports-project-tab_543x73.png" style="width: 543;height: 73;" /></li>
            <li value="3">Choose <b class="UISelection">Replay Scripts</b> from the <b class="UISelection">Export Format</b> section.<br /><br /><img src="../Resources/Images/exports/exports-replay-type_545x44.png" title="Export type" alt="Export type" style="width: 545;height: 44;" /></li>
            <li value="4">Use the <b class="UISelection">Included addresses</b> to explicitly define the hosts you want to include in the replay scripts. (Optional)<br /></li>
            <li value="5">Use the <b class="UISelection">Excluded addresses</b> to explicitly define the hosts you want to exclude from the replay scripts. (Optional)</li>
            <li value="6">If you do not want to include credentials in the export,  select the <b class="UISelection">Mask credentials</b> option from the <b class="UISelection">Export Options</b> section.</li>
            <li value="7">Click the <b class="UISelection">Export Data</b> button. <br /><br />When the export begins, you will be taken back to the Exports page. The Exports page displays an "Export creation queued" message. <br /><br />The Notification Center icon will turn green and alert you when  the export starts and completes.  You can click on the Notification Center icon to view a list of system wide alerts. When the export completes, you can click on the notification message or you can select<b class="UISelection"> Exports &gt;&#160;Show Exports</b> from the Project tab bar to access the Exports area. <br /><br />The ZIP file will listed be at the top of the Exports List. It will use the following naming convention: <code>export-[current date and time]</code>. If you do not see it at the top of the Exports List, click on the Create Date column name to sort the list by descending creation date.<br /><br />If an error occurred during the export and the export was unable to complete, you can view the export log to identify and troubleshoot any errors that occurred. For more information on export logs, see <MadCap:conditionalText data-mc-conditions="Pro_Help_Conditions.OnlineOnly"> <![CDATA[ ]]><a href="#Export" class="online MCXref xref xrefonline">Export Logs</a></MadCap:conditionalText>.<br /><br /></li>
        </ol>
        <h4>Running the Replay Script with the Pro&#160;Console or MSFConsole</h4>
        <p>To run the replay script, you need to use the <code>resource</code> command. It  loads the batch files and run them through the pro console or msfconsole.The resource command needs to include the path to the replay script. For example, you can enter <code class="usertype">resource /path/to/session_ID_IP.rc</code> to load the replay script and run the commands stored in the file.</p>
        <p class="Note" data-mc-autonum="&lt;b&gt;Note:&lt;/b&gt; &#160;"><span class="autonumber"><span><b>Note:</b> &#160;</span></span>Before you can run the resource file, you will need to extract them from the ZIP file. <br /></p>
        <h3>PWDumps</h3>
        <p>A PWDump is a text file that contains all of the credentials for a project, including plaintext passwords, SMB hashes, and SSH keys. You can export a PWDump file to perform offline password cracking with a tool like John the Ripper.</p>
        <h3>Exporting  a PWDump</h3>
        <ol>
            <li value="1">Open the project from which you want to export data. </li>
            <li value="2">Select <b class="UISelection">Exports &gt;&#160;Export Data</b> from the Project tab bar. The <b class="UISelection">Export Data</b> page appears. <br /><br /><img src="../Resources/Images/exports/exports-project-tab_545x73.png" title="Exports menu" alt="Exports menu" style="width: 545;height: 73;" /></li>
            <li value="3">Select <b class="UISelection">PWDump</b> from the <b class="UISelection">Export Format</b> section. <br /><br /><img src="../Resources/Images/exports/exports-pswd-type_547x42.png" title="Export type" alt="Export type" style="width: 547;height: 42;" /></li>
            <li value="4">Use the <b class="UISelection">Included addresses</b> to explicitly define the hosts you want to include in the export. (Optional)<br /></li>
            <li value="5">Use the <b class="UISelection">Excluded addresses</b> to explicitly define the hosts you want to exclude from the export. (Optional)</li>
            <li start="5" value="6">
                <li value="5">Click the <b class="UISelection">Export Data</b> button. </li>
                <li class="indentedListNextLine" value="6" data-mc-autonum=""><span class="autonumber"><span></span></span>When the export begins, you will be taken back to the Exports page. </li>
                <li class="indentedListNextLine" value="7" data-mc-autonum=""><span class="autonumber"><span></span></span>The Notification Center icon will turn green and alert you when  the export starts and completes. You can click on the Notification Center icon to view a list of system wide alerts. When the export completes, you can click on the notification message or you can select<b class="UISelection"> Exports &gt;&#160;Show Exports</b> from the Project tab bar to access the Exports area. </li>
                <li class="indentedListNextLine" value="8" data-mc-autonum=""><span class="autonumber"><span></span></span>The PWDump will listed be at the top of the Exports List. It will use the following naming convention: <code>export-[current date and time]</code>. If you do not see it at the top of the Exports List, click on the Create Date column name to sort the list by descending creation date.</li>
                <li class="indentedListNextLine" value="9" data-mc-autonum=""><span class="autonumber"><span></span></span>If an error occurred during the export and the export was unable to complete, you can view the export log to identify and troubleshoot any errors that occurred. For more information on export logs, see <MadCap:conditionalText data-mc-conditions="Pro_Help_Conditions.OnlineOnly"> <![CDATA[ ]]><a href="#Export" class="online MCXref xref xrefonline">Export Logs</a></MadCap:conditionalText>.</li>
            </li>
        </ol>
        <h2>Viewing Exported Data</h2>
        <p>To see a list of exported data, select <b class="UISelection">Exports &gt;&#160;Show Exports</b> from the Project tab bar. The Data Exports list will display all exports associated with the project. You can click on the <b class="UISelection">Download</b> or <b class="UISelection">View</b> link to access each item. </p>
    </body>
</html>